﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace czolg_1
{
    internal class Pocisk
    {
        int[] klatki = {0,1,2,3};
        private int wys, szer;//wysokośc i szerokośc klatki świata gry
        public float x, y;//pozycja we współrzednych ekranowych
        private float x0, y0;//pozycja współrzednych wystrzału
        public int idKlatka = 0;
        public bool fZniszcz = false;
        //opóźnienie
        private const byte GRANICA_OPOZNIENIE = 3;
        private byte licznikOpoznienia = 0;
        private byte kierunek;
        private float v = 10.0f;//predkośc pocisku
        private float zasieg = 0;//zasięg pocisku
        //
        public Czolg wlasciciel;
        
        //konstruktor
        public Pocisk(float _x, float _y, int _wys, int _szer, byte _kierunek, Czolg _w)
        {
            //przesuniecie dla konca lufy
            float dx = 0, dy = 0;
            wys = _wys;
            szer = _szer;
            //kierunek strzalu
            kierunek = _kierunek;
            switch (kierunek)
            {
                //Północ
                case 0:dy = -24.0f;break;
                //Wschód
                case 1:dx = 24.0f; break;
                //Polódnie
                case 2:dy = 24.0f;break;
                //Zachód
                case 3:dx = -24.0f;break;
            }
            //zapamietaj współrzędne strzalu
            x = _x + dx;
            y = _y + dy;
            x0 = _x;
            y0 = _y;
            
            //ustaw zasięg na 6 kafli świata
            zasieg = 6 * 48;
            wlasciciel = _w;
        }

        public void Rysuj(Graphics g, List<Bitmap> bmp, int id)
        {
            g.DrawImage(bmp[klatki[id]],
                        new Rectangle((int)x - szer / 2, (int)y - wys / 2, szer, wys),
                        new Rectangle(0, 0, szer, wys),
                        GraphicsUnit.Pixel);
        }
        public void Ruch()
        {
            //kierunek pólnoc
            switch (kierunek)
            {
                //na Pólnoc
                case 0:y -= v;break;
                //na Wschod
                case 1:x += v;break;
                //na Południe
                case 2: y += v; break;
                //na Zachód
                case 3: x -= v; break;
            }
            if (Math.Abs(x - x0) > zasieg || Math.Abs(y - y0) > zasieg)
                fZniszcz = true;
        }
        public void LicznikKlatek()
        {
            licznikOpoznienia++;
            if (licznikOpoznienia > GRANICA_OPOZNIENIE)
            {
                idKlatka++;
                licznikOpoznienia = 0;
            }
            if (idKlatka > 3)
            {
                idKlatka = 0;
                //flagę zniszcenia trzeba wywołac gdy trafiono w cel
                //przeszkodę lub osiągnieto maksymalny zasięg
                //fZniszcz = true;
            }
        }
    }
}
